"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide6.QtQml, except for defaults which are replaced by "...".
"""
from __future__ import annotations

from enum import IntFlag

import PySide6.QtCore
import PySide6.QtNetwork
import PySide6.QtQml

class QQmlImageProviderBase(PySide6.QtCore.QObject):
    """
    https://doc.qt.io/qt-6/qqmlimageproviderbase.html

    **Detailed Description**

    Image providers must be registered with the QML engine. The only information
    the QML engine knows about image providers is the type of image data they
    provide. To use an image provider to acquire image data, you must cast the
    QQmlImageProviderBase pointer to a **QQuickImageProvider**  pointer.

    **See also** **QQuickImageProvider**  and **QQuickTextureFactory** .
    """

    ForceAsynchronousImageLoading: QQmlImageProviderBase.Flag = ...
    Invalid: QQmlImageProviderBase.ImageType = ...
    Image: QQmlImageProviderBase.ImageType = ...
    Pixmap: QQmlImageProviderBase.ImageType = ...
    Texture: QQmlImageProviderBase.ImageType = ...
    ImageResponse: QQmlImageProviderBase.ImageType = ...

    class Flag(IntFlag):
        ForceAsynchronousImageLoading: QQmlImageProviderBase.Flag = ...

    class Flags: ...

    class ImageType(IntFlag):
        Invalid: QQmlImageProviderBase.ImageType = ...
        Image: QQmlImageProviderBase.ImageType = ...
        Pixmap: QQmlImageProviderBase.ImageType = ...
        Texture: QQmlImageProviderBase.ImageType = ...
        ImageResponse: QQmlImageProviderBase.ImageType = ...
    def flags(self) -> PySide6.QtQml.QQmlImageProviderBase.Flags:
        """
        https://doc.qt.io/qt-6/qqmlimageproviderbase.html#flags

        **[pure virtual] QQmlImageProviderBase::Flags
        QQmlImageProviderBase::flags() const**

        Implement this to return the properties of this image provider.
        """
        ...
    def imageType(self) -> PySide6.QtQml.QQmlImageProviderBase.ImageType:
        """
        https://doc.qt.io/qt-6/qqmlimageproviderbase.html#imageType

        **[pure virtual] QQmlImageProviderBase::ImageType
        QQmlImageProviderBase::imageType() const**

        Implement this method to return the image type supported by this image
        provider.
        """
        ...
